FSEconomy X-Plane Client API
============================

The FSEconomy X-Plane Client (xfse) exposes some commands and data refs in X-Plane that can be accessed by third-party plugins or scripts.

Please note: while we try to keep this API stable, we cannot guarantee there won't be changes, particularly when major version changes occur.

Data Refs
---------

* fse/status/connected
  type: integer
  returns 1 if client is connected to the FSEconomy server (i. e. has logged in successfully), otherwise 0

* fse/status/flying
  type: integer
  returns 1 if flight is active (i. e. flight has been started successfully, but not yet ended), otherwise 0

* fse/status/leasetime
  type: integer
  returns lease time in seconds

* fse/status/flighttime
  type: integer
  returns flight time in seconds, factoring in time compression and ground speed acceleration

* fse/status/canendflight
  type: integer
  returns 1 if prerequisits are met to issue the end flight command, otherwise 0

* fse/status/FSEfueltype
  type: integer
  returns 1 if FSE expects aircraft to consume JetA, otherwise 0
  limitation: only meaningful while flight is active (fse/status/flying == 1)
  **New in 1.9.4**

Commands
--------

* fse/server/connect
  Log in to the FSEconomy server. If successfully executed, fse/status/connected will be set to 1
  To avoid unnecessary server connections, it is recommended to check fse/status/connected before issuing this command.

* fse/window/show
  Show the xfse window. Does nothing if window already visible.

* fse/window/hide
  Hide the xfse window. Does nothing if window already hidden.

* fse/window/toggle
  Toggle visibility of the xfse window.

* fse/flight/start
  Start FSE flight. This entails starting the lease timer, flight time recording, loading of fuel and payload and locking of unavailable avionics.
  If successfully executed, fse/status/flying will be set to 1
  It is recommended to check fse/status/connected before issuing this command, and checking fse/status/flying thereafter.

* fse/flight/finish
  Finish FSE flight and submit results to the FSE server.
  Necessary preconditions for the command to be executed: fse/status/flying and fse/status/canendflight must both read 1
  If successfully executed, fse/status/flying will be set to 0

* fse/flight/cancelArm
  Arm flight cancellation.
  Necessary precondition: fse/status/flying must read 1

* fse/flight/cancelConfirm
  Cancel flight and submit cancellation to FSE server. fse/flight/cancelArm must have been executed upfront, otherwise the command will do nothing.
  Necessary precondition: fse/status/flying must read 1
  If successfully executed, fse/status/flying will be set to 0
